/*
* @Author: Qiaosen Huang
* @Date:   2016-12-26 17:48:16
* @Last Modified by:   Qiaosen Huang
* @Last Modified time: 2017-01-10 16:42:19
*/

'use strict';
const path = require('path');
const co = require('co');
const spawn = require('child_process').spawn;
const fs = require('fs.extra');
const build = require('./build')
const app = require('koa')();
const bodyParser = require('koa-bodyparser');
const Router = require('koa-router');
const oss = require('ali-oss');
const bookTemplate = require('./template');

const cdn = oss({
  accessKeyId: 'LTAIEoTr6e2FrAds',
  accessKeySecret: 'VszQsT02YgoHhXgZYqxdSaiKk5JVTO',
  bucket: 'assetsfordwd',
  region: 'oss-cn-hangzhou',
});

function* run(cmd, args) {
    yield cb => {
        const exe = spawn(cmd, args);
        let err = '';
        
        exe.stdout.on('data', data => {
        });

        exe.stderr.on('data', data=> {
            err += data.toString();
        });

        exe.on('exit', code => {
            if (code === 0) return cb();
            cb(err);
        });
    };
}

function* pullAndBuild(url) {
    console.log(url)
    const name = Date.now().toString();
    yield run('git', ['clone', url, name]);
    build(path.resolve(__dirname, name));
    fs.writeFileSync(path.resolve(__dirname, 'book.js'), 'module.exports = ' + JSON.stringify(Object.assign(
        {
            root: `./${name}`,
        },
        bookTemplate
    )));
    console.log('build')
    yield run('./node_modules/.bin/gitbook', ['build']);
    return name;
};

function *walk(dir) {
    const children = yield cb => fs.readdir(dir, cb);
    let files = [];
    const reqs = [];
    for (const child of children) {
        const file = path.resolve(dir, child);
        const stat = yield cb => fs.lstat(file, cb);
        if (stat.isDirectory()) {
            reqs.push(walk(file));
        } else {
            files.push(file);
        }
    }
    const result = yield reqs;
    files = files.concat(result.reduce((l, f) => l.concat(f), []));
    return files;
}

function* publish() {
    const book = path.resolve(__dirname, '_book');
    const files = yield walk(book);
    for (const file of files) {
        yield cdn.put(`/rider-wiki/${path.relative(book, file)}`, file);
    }
    console.log('uploaded')
}

app.use(bodyParser());

const router = new Router();
router.post('/', function* (next) {
    const body = this.request.body;
    if (
        body.project  &&
        body.project.name === 'content' &&
        body.project.namespace === 'dianwoba-gitbook' &&
        body.password === 'xGYwaLCjxKkMS3572HDYbYDL'
    ) {
        this.body = 'success';
        this.status = 200;
        yield next;
        const name = yield pullAndBuild(body.project.git_ssh_url);
        /*
        try {
            yield publish();
        } catch (e) {
            console.error(e.stack || e);
            yield publish();
        }
        */
        //fs.rmrfSync(path.resolve(__dirname, '_book'));
        //fs.rmrfSync(path.resolve(__dirname, 'book.js'));
        //fs.rmrfSync(path.resolve(__dirname, name));
    }
});

app.use(router.routes());

app.listen(process.env.HTTP_PORT || 26880);
console.log(`Server up at ${process.env.HTTP_PORT || 26880}`);
